我想在启动时启动一些 python 脚本(使用 venv)并监视状态,以便在出现问题时自动重新启动它。
我做了: - 一个简单的 python 示例prg.py
,它永远休眠并在收到 sigint 信号时退出。
一个 bash 脚本
prg.sh
,用于监视prg.py
.如果进程停止,脚本将重新启动程序。如果脚本收到 sigint,它将向prg.py
程序发送 sigint 并退出。用于启动 bash 脚本 ( ) 的脚本
init.d
( ) 。的代码不是我的,我在GitHub上找到并修改了它。我正在搜索链接,当我找到它时,我将编辑帖子。prg
prg.sh
prg
prg.py
:
import signal
import time
def signal_handler(sig, frame):
print('sigint')
quit(0)
signal.signal(signal.SIGINT, signal_handler)
print ('aaa')
while (1):
time.sleep(1.5)
prg.sh
:
#!/bin/bash
#set -x
DIR="/home/pi"
PRESCRIPT="source venv/bin/activate;python --version"
SCRIPT="python prg.py"
EXITDO=0
PID=-1
trap ctrl_c INT
function ctrl_c() {
echo 'SIGINT intercepted.'
EXITDO=1
}
#Main loop
while [ $EXITDO -eq 0 ]; do
echo 'Starting process…'
cd "$DIR"
eval $PRESCRIPT
$SCRIPT &
PID=$(echo $!)
echo "Process started with PID: $PID"
while $(kill -0 $PID) && [ $EXITDO -eq 0 ]; do
sleep 1
done
if [ $EXITDO -eq 0 ]; then
echo 'Process terminated. Restart.'
else
echo 'Kill service.'
kill -2 $PID
fi
done
prg
:
#!/bin/sh
### BEGIN INIT INFO
# Provides: prg
# Required-Start: $local_fs $network $named $time $syslog
# Required-Stop: $local_fs $network $named $time $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Description: <DESCRIPTION>
### END INIT INFO
NAME=prg
SCRIPT="/home/pi/prg.sh"
PIDFILE=/var/run/$NAME.pid
start() {
if [ -f $PIDFILE ] && [ -s $PIDFILE ] && kill -0 $(cat $PIDFILE); then
echo 'Service already running' >&2
return 1
fi
echo 'Starting service…' >&2
#local CMD="$SCRIPT &> \"$LOGFILE\" & echo \$!"
#su -c "$CMD" $RUNAS > "$PIDFILE"
# Try with this command line instead of above if not workable
# su -s /bin/sh $RUNAS -c "$CMD" > "$PIDFILE"
$SCRIPT &
echo $! > "$PIDFILE"
PID=$(cat $PIDFILE)
if kill -0 $(cat $PIDFILE) > /dev/null
then
echo "$NAME is now running, the PID is $PID"
else
echo ''
echo "Error! Could not start $NAME!"
fi
}
stop() {
if [ ! -f "$PIDFILE" ] || ! kill -0 $(cat "$PIDFILE"); then
echo 'Service not running' >&2
return 1
fi
echo 'Stopping service…' >&2
#Kill by pid
kill -2 $(cat "$PIDFILE")
#remove .pid file
sleep 3
if ! kill -0 $(cat "$PIDFILE"); then
rm -f "$PIDFILE"
echo 'Service stopped' >&2
fi
}
uninstall() {
echo -n "Are you really sure you want to uninstall this service? That cannot be undone. [yes|No] "
local SURE
read SURE
if [ "$SURE" = "yes" ]; then
stop
rm -f "$PIDFILE"
echo "Notice: log file was not removed: $LOGFILE" >&2
update-rc.d -f $NAME remove
rm -fv "$0"
else
echo "Abort!"
fi
}
status() {
printf "%-50s" "Checking $NAME..."
if [ -f $PIDFILE ] && [ -s $PIDFILE ]; then
PID=$(cat $PIDFILE)
if [ -z "$(ps axf | grep ${PID} | grep -v grep)" ]; then
printf "%s\n" "The process appears to be dead but pidfile still exists"
else
echo "Running, the PID is $PID"
fi
else
printf "%s\n" "Service not running"
fi
}
case "$1" in
start)
start
;;
stop)
stop
;;
status)
status
;;
uninstall)
uninstall
;;
restart)
stop
start
;;
*)
echo "Usage: $0 {start|stop|status|restart|uninstall}"
esac
如果我启动
prg.sh
程序按预期运行。我可以杀死
prg.py
并prg.sh
自动重新启动prg.py
.我可以发送一个
sigint
toprg.sh
并prg.sh
停止prg.py
并自行关闭。我可以启动
prg
withsudo service prg start
命令,一切正常。
但
在这种情况下,如果我发送一个
sigint
toprg.sh
,什么也不会发生。简而言之,
service prg stop
不起作用,我不明白为什么。
提前致谢。